#include<mgtk/editor.h>
#include<mgtk/bitmap.h>
#include<stdlib.h>
#include"mystring.h"

GClipboard::GClipboard()
{
 buf_location=NULL;
 size=0;
 data_type=CL_EMPTY; 
}

GClipboard::~GClipboard()
{
 Empty();
}

void * GClipboard::GetData()
{
 return buf_location;
}

GClipboard::clip_data_type_t GClipboard::GetDataType()
{
 return data_type;
}

unsigned long GClipboard::GetDataSize()
{
 return size;
}

void GClipboard::Empty()
{
 switch(data_type)
 {
  case CL_EMPTY:
   break;
  case CL_BINARY:
  case CL_TEXT:
   free(buf_location);
   buf_location=NULL;
   size=0;
   break;
  case CL_IMAGE:
  {
   GImagePool * Img=(GImagePool *)buf_location;
   delete Img;
   buf_location=NULL;
   size=0;
   break;
  }
 }
 data_type=CL_EMPTY;
}

void GClipboard::SetClipData(clip_data_type_t type,void * ptr,unsigned long _size)
{
 Empty();
 switch(type)
 {
  case CL_EMPTY:
   return;
  case CL_TEXT:
  case CL_BINARY:
   buf_location=malloc(_size);
   if(!buf_location) return;
   memcpy(buf_location,ptr,_size);
   size=_size;
   data_type=type;
   return;
  case CL_IMAGE:
  {
   GImagePool * Img,* Imgp;
   Imgp=(GImagePool *)ptr;
   Img=Imgp->Duplicate(Imgp);
   if(!Img) return;
   buf_location=(void *)Img;
   size=_size;
   data_type=CL_IMAGE;
   return;
  }
 }
}
