#include<mgtk/editor.h>
#include<mgtk/bitmap.h>
#include<stdlib.h>
#include"mystring.h"
//#define CL_TEXT 3

#define BUFSZ_ALIGN(x) 	(((x)+127)&~127)

GEditorCore::GEditorCore(unsigned long SizeLim)
{
 size_limit=SizeLim;
 text_buffer=NULL;
 text_size=0;
 buffer_size=0;
 case_sensitive=false;
}

GEditorCore::~GEditorCore()
{
 Empty();
}

int GEditorCore::ExpandBuffer(int Delta)
{
 unsigned long newsz;
 char * newbuf;
 newsz=text_size+Delta;
 if(newsz<=0)
 {
  Empty();
  return 0; /* OK */
 }
 newsz=BUFSZ_ALIGN(newsz);
 if(newsz<=buffer_size) return 0; /* OK */
 if(newsz>size_limit) newsz=size_limit-text_size;
 if(!newsz) return -1; /* Unable to do */
 newbuf=(char *)realloc(text_buffer,newsz);
 if(!newbuf) return -2; /* No memory left */
 buffer_size=newsz;
 text_buffer=newbuf; 
 return 0;
}

void GEditorCore::Empty()
{
 if(!buffer_size || !text_buffer) return;
 buffer_size=0;
 text_size=0;
 free(text_buffer);
 text_buffer=NULL;
}

bool GEditorCore::IsEmpty()
{
 return !buffer_size;
}

void GEditorCore::SetCaseSensitive(bool v)
{
 case_sensitive=v;
}

char * GEditorCore::GetTextBuffer()
{
 return text_buffer;
}

unsigned long GEditorCore::GetTextSize()
{
 return text_size;
}

void GEditorCore::Delete(unsigned long offset,unsigned long size)
{
 if(!size) return;
 if(offset==INVALID_EDITOR_OFFSET) return;
 if(!offset && size>=text_size)
 {
  Empty();
  return;
 }
 if((offset+size)>=text_size)
 {
  ExpandBuffer(-(text_size-offset));
  return;
 }
 memcpy(text_buffer+offset,text_buffer+offset+size,text_size-(offset+size));
 ExpandBuffer(-size);
}

void GEditorCore::Copy(unsigned long offset,unsigned long size,
     GClipboard * Clip)
{
 if(!size) return;
 if(offset==INVALID_EDITOR_OFFSET) return;
 if((offset+size)>=text_size) size=text_size-offset;
 Clip->SetClipData(GClipboard::CL_TEXT,(void *)(offset+text_buffer),size);
}

void GEditorCore::Cut(unsigned long offset,unsigned long size,
     GClipboard * Clip)
{
 Copy(offset,size,Clip);
 Delete(offset,size);
}

void GEditorCore::Paste(unsigned long offset,GClipboard * Clip)
{
 unsigned long size;
 GClipboard::clip_data_type_t dt;
 dt=Clip->GetDataType();
 if(dt!=3) return;
 size=Clip->GetDataSize();
}
