#include<mgtk/terminal.h>
#include<mgtk/pen.h>
#include<mgtk/text.h>
#include<stdlib.h>
#include"mystring.h"

GTerminal::GTerminal(GRect * r,int cursor_vis,unsigned long TextColor,
	unsigned long BackgrColor):GWidget()
{
 SetBounds(r);
 _tcolor=TextColor;
 _bcolor=BackgrColor;
 cx=0;
 cy=0;
 xchars=(Size.x-4)/(SMALL_FONT_XSZ+1);
 ychars=(Size.y-4)/(SMALL_FONT_YSZ+1);
 screen_buf=(char *)malloc(xchars*ychars);
 if(!screen_buf)
 {
  xchars=ychars=0;
  return;
 }
 ClrScr();
}

GTerminal::~GTerminal()
{
 free((void *)screen_buf);
}

void GTerminal::DrawWidget()
{
 int y;
 char * bufp;
 GPen Pen(this);
 Pen.Rect(0,0,Size.x-1,Size.y-1,RGB(0x80,0,0));
 Pen.FillRect2(1,1,Size.x-2,Size.y-2,_bcolor);
 for(bufp=screen_buf,y=0;y<ychars;y++,bufp+=xchars)
 {
  Pen.WriteText(2,2+(y*(SMALL_FONT_YSZ+1)),bufp,xchars,_tcolor);
 }
}

void GTerminal::Scroll()
{
 memcpy(screen_buf,screen_buf+xchars,xchars*(ychars-1));
 memset(screen_buf+(xchars*(ychars-1)),' ',xchars);
 DrawWidget();
}

void GTerminal::Putch(char c)
{
 char * screenp=screen_buf+(xchars*cy)+cx;
 if(c=='\r')
 {
  cx=0;
 } else if(c=='\n')
 {
  cx=0;
  cy++;
 } else {
  *screenp=c;
  LocalUpdate();
  cx++;
 }
 if(cx>=xchars)
 {
  cx=0;
  cy++;
 }
 if(cy>=ychars)
 {
  cy=ychars-1;
  Scroll();
 }
}

void GTerminal::ClrScr()
{
 memset(screen_buf,' ',xchars*ychars);
}

void GTerminal::Idle()
{
 GWidget::Idle();
}

void GTerminal::LocalUpdate()
{
 int _x,_y;
 GPen Pen(this);
 _x=2+(cx*(SMALL_FONT_XSZ+1));
 _y=2+(cy*(SMALL_FONT_YSZ+1));
 Pen.FillRect2(_x,_y,SMALL_FONT_XSZ+1,SMALL_FONT_YSZ+1,_bcolor);
 Pen.WriteText(_x,_y,screen_buf+cx+(xchars*cy),1,_tcolor);
}
